<?php

namespace FiloBlu\ExtAnowaveGtmEnhancedEcommerceUaTrackingEc\Block;

class Result extends \Anowave\Ec\Block\Result {

    /**
     * Augment search results block 
     * 
     * @param \Magento\CatalogSearch\Block\Result $block
     * @param string $content
     * @return string
     */
    public function afterGetProductListHtml($block, $content) {
        /**
         * Retrieve list of impression product(s)
         * 
         * @var array
         */
        $products = array();

        foreach ($block->getListBlock()->getLoadedProductCollection() as $product) {
            $products[] = $product;
        }

        /**
         * Append tracking
         */
        $doc = new \DOMDocument('1.0', 'utf-8');
        $dom = new \DOMDocument('1.0', 'utf-8');

        @$dom->loadHTML(mb_convert_encoding($content, 'HTML-ENTITIES', 'UTF-8'));

        $query = new \DOMXPath($dom);

        foreach ($query->query($this->_helper->getConfig('ec/selectors/list')) as $key => $element) {
            if (isset($products[$key])) {
                /**
                 * Add data-* attributes used for tracking dynamic values
                 */
                foreach ($query->query($this->_helper->getConfig('ec/selectors/click'), $element) as $a) {
                    $click = $a->getAttribute('onclick');

                    $a->setAttribute('data-id', $this->_helper->escapeDataArgument($products[$key]->getSku()));
                    $a->setAttribute('data-name', $this->_helper->escapeDataArgument($products[$key]->getName()));
                    $a->setAttribute('data-price', $this->_helper->escapeDataArgument($this->_helper->getPrice($products[$key])));
                    $a->setAttribute('data-category', 'Search results');
                    $a->setAttribute('data-list', 'Search results');
                    $a->setAttribute('data-brand', $this->_helper->escapeDataArgument($this->_helper->getBrand($products[$key])));
                    $a->setAttribute('data-quantity', 1);
                    $a->setAttribute('data-click', $click);
                    $a->setAttribute('data-store', $this->_helper->getStoreName());
                    $a->setAttribute('onclick', 'return AEC.click(this,dataLayer)');
                }

                /**
                 * Direct "Add to cart" from search results
                 */
                if ('' !== $selector = $this->_helper->getConfig('ec/selectors/cart_list')) {
                    foreach (@$query->query($selector, $element) as $a) {
                        $click = $a->getAttribute('onclick');

                        $a->setAttribute('data-id', $this->_helper->escapeDataArgument($products[$key]->getSku()));
                        $a->setAttribute('data-name', $this->_helper->escapeDataArgument($products[$key]->getName()));
                        $a->setAttribute('data-price', $this->_helper->escapeDataArgument($this->_helper->getPrice($products[$key])));
                        $a->setAttribute('data-category', 'Search results');
                        $a->setAttribute('data-list', 'Search results');
                        $a->setAttribute('data-brand', $this->_helper->escapeDataArgument($this->_helper->getBrand($products[$key])));
                        $a->setAttribute('data-quantity', 1);
                        $a->setAttribute('data-click', $click);
                        $a->setAttribute('data-store', $this->_helper->getStoreName());
                        $a->setAttribute('onclick', 'return AEC.ajaxList(this,dataLayer)');
                    }
                }
            }
        }

        return $this->_helperDom->getDOMContent($dom, $doc);
    }

}
